ompi/mca/bml/bml.h File Reference.TH "ompi/mca/bml/bml.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/bml/bml.h \- BML Management Layer (BML). 
.SH SYNOPSIS
.br
.PP
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/btl/btl.h'\fP
.br
\fC#include 'mca/bml/base/bml_base_btl.h'\fP
.br
\fC#include 'mca/bml/base/bml_base_endpoint.h'\fP
.br
\fC#include 'include/types.h'\fP
.br
\fC#include 'class/ompi_free_list.h'\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_BML_BASE_BTL_DES_ALLOC\fP(bml_btl, descriptor, alloc_size, seg_size)"
.br
.ti -1c
.RI "#define \fBMCA_BML_BASE_BTL_DES_RETURN\fP(bml_btl, descriptor)"
.br
.RI "\fIReturn a descriptor. \fP"
.ti -1c
.RI "#define \fBMCA_BML_BASE_VERSION_1_0_0\fP"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef mca_bml_base_btl_t \fBmca_bml_base_btl_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_bml_base_btl_array_t\fP \fBmca_bml_base_btl_array_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_bml_base_endpoint_t\fP \fBmca_bml_base_endpoint_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_bml_base_module_t\fP *(* \fBmca_bml_base_component_init_fn_t\fP )(int *priority, bool enable_progress_threads, bool enable_mpi_threads)"
.br
.RI "\fIMCA->BML Initializes the BML component and creates specific BML module(s). \fP"
.ti -1c
.RI "typedef int(* \fBmca_bml_base_module_progress_fn_t\fP )(void)"
.br
.RI "\fIMCA->BML Called to progress outstanding requests for non-threaded polling environments. \fP"
.ti -1c
.RI "typedef \fBmca_bml_base_component_1_0_0_t\fP \fBmca_bml_base_component_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_bml_base_component_1_0_0_t\fP \fBmca_bml_base_component_t\fP"
.br
.ti -1c
.RI "typedef int(* \fBmca_bml_base_module_finalize_fn_t\fP )(void)"
.br
.RI "\fIMCA->BML Clean up any resources held by BML module before the module is unloaded. \fP"
.ti -1c
.RI "typedef int(* \fBmca_bml_base_module_add_procs_fn_t\fP )(size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_bml_base_endpoint_t\fP **endpoints, struct ompi_bitmap_t *reachable)"
.br
.RI "\fIPML->BML notification of change in the process list. \fP"
.ti -1c
.RI "typedef int(* \fBmca_bml_base_module_del_procs_fn_t\fP )(size_t nprocs, struct ompi_proc_t **procs)"
.br
.RI "\fINotification of change to the process list. \fP"
.ti -1c
.RI "typedef void(* \fBmca_bml_base_module_recv_cb_fn_t\fP )(\fBmca_btl_base_module_t\fP *bml_btl, mca_btl_base_tag_t tag, \fBmca_btl_base_descriptor_t\fP *descriptor, void *cbdata)"
.br
.RI "\fICallback function that is called asynchronously on receipt of data by the transport layer. \fP"
.ti -1c
.RI "typedef int(* \fBmca_bml_base_module_register_fn_t\fP )(mca_btl_base_tag_t tag, \fBmca_bml_base_module_recv_cb_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fIRegister a callback function that is called on receipt of a fragment. \fP"
.ti -1c
.RI "typedef \fBmca_bml_base_module_t\fP \fBmca_bml_base_module_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (\fBmca_bml_base_btl_array_t\fP)"
.br
.ti -1c
.RI "int \fBmca_bml_base_btl_array_reserve\fP (\fBmca_bml_base_btl_array_t\fP *, size_t)"
.br
.RI "\fIIf required, reallocate (grow) the array to the indicate size. \fP"
.ti -1c
.RI "static size_t \fBmca_bml_base_btl_array_get_size\fP (\fBmca_bml_base_btl_array_t\fP *array)"
.br
.ti -1c
.RI "static void \fBmca_bml_base_btl_array_set_size\fP (\fBmca_bml_base_btl_array_t\fP *array, size_t size)"
.br
.RI "\fIGrow the array if required, and set the size. \fP"
.ti -1c
.RI "static mca_bml_base_btl_t * \fBmca_bml_base_btl_array_insert\fP (\fBmca_bml_base_btl_array_t\fP *array)"
.br
.RI "\fIGrow the array size by one and return the item at that index. \fP"
.ti -1c
.RI "static mca_bml_base_btl_t * \fBmca_bml_base_btl_array_get_index\fP (\fBmca_bml_base_btl_array_t\fP *array, size_t index)"
.br
.RI "\fIReturn an array item at the specified index. \fP"
.ti -1c
.RI "static mca_bml_base_btl_t * \fBmca_bml_base_btl_array_get_next\fP (\fBmca_bml_base_btl_array_t\fP *array)"
.br
.RI "\fIReturn the next LRU index in the array. \fP"
.ti -1c
.RI "static mca_bml_base_btl_t * \fBmca_bml_base_btl_array_find\fP (\fBmca_bml_base_btl_array_t\fP *array, struct \fBmca_btl_base_module_t\fP *btl)"
.br
.RI "\fILocate an element in the array. \fP"
.ti -1c
.RI "OMPI_COMP_EXPORT \fBOBJ_CLASS_DECLARATION\fP (\fBmca_bml_base_endpoint_t\fP)"
.br
.ti -1c
.RI "static void \fBmca_bml_base_alloc\fP (mca_bml_base_btl_t *bml_btl, \fBmca_btl_base_descriptor_t\fP **des, size_t size)"
.br
.ti -1c
.RI "static void \fBmca_bml_base_free\fP (mca_bml_base_btl_t *bml_btl, \fBmca_btl_base_descriptor_t\fP *des)"
.br
.ti -1c
.RI "static int \fBmca_bml_base_send\fP (mca_bml_base_btl_t *bml_btl, \fBmca_btl_base_descriptor_t\fP *des, mca_btl_base_tag_t tag)"
.br
.ti -1c
.RI "static int \fBmca_bml_base_put\fP (mca_bml_base_btl_t *bml_btl, \fBmca_btl_base_descriptor_t\fP *des)"
.br
.ti -1c
.RI "static int \fBmca_bml_base_get\fP (mca_bml_base_btl_t *bml_btl, \fBmca_btl_base_descriptor_t\fP *des)"
.br
.ti -1c
.RI "static void \fBmca_bml_base_prepare_src\fP (mca_bml_base_btl_t *bml_btl, mca_mpool_base_registration_t *reg, struct ompi_convertor_t *conv, size_t reserve, size_t *size, \fBmca_btl_base_descriptor_t\fP **des)"
.br
.ti -1c
.RI "static void \fBmca_bml_base_prepare_dst\fP (mca_bml_base_btl_t *bml_btl, mca_mpool_base_registration_t *reg, struct ompi_convertor_t *conv, size_t reserve, size_t *size, \fBmca_btl_base_descriptor_t\fP **des)"
.br
.in -1c
.SH "Detailed Description"
.PP 
BML Management Layer (BML). 


.SH "Define Documentation"
.PP 
.SS "#define MCA_BML_BASE_BTL_DES_ALLOC(bml_btl, descriptor, alloc_size, seg_size)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                                     \
    if(NULL != (descriptor = bml_btl->btl_cache)) {                                      \
        bml_btl->btl_cache = NULL;                                                       \
    } else {                                                                             \
        descriptor = bml_btl->btl_alloc(bml_btl->btl, alloc_size);                       \
    }                                                                                    \
    descriptor->des_src->seg_len = seg_size;                                             \
    descriptor->des_context = (void*) bml_btl;                                           \
} while(0)
.fi
.SS "#define MCA_BML_BASE_BTL_DES_RETURN(bml_btl, descriptor)"
.PP
\fBValue:\fP
.PP
.nf
do {                                                                                     \
    if(NULL == bml_btl->btl_cache) {                                                     \
        bml_btl->btl_cache = descriptor;                                                 \
    } else {                                                                             \
        bml_btl->btl_free(bml_btl->btl,descriptor);                                      \
    }                                                                                    \
} while(0)
.fi
Return a descriptor. 
.PP
.SS "#define MCA_BML_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/*  v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* bml v1.0 */ \
  'bml', 1, 0, 0
.fi
.SH "Typedef Documentation"
.PP 
.SS "typedef struct \fBmca_bml_base_module_t\fP*(* \fBmca_bml_base_component_init_fn_t\fP)(int *priority, bool enable_progress_threads, bool enable_mpi_threads)"
.PP
MCA->BML Initializes the BML component and creates specific BML module(s). 
.PP
\fBParameters:\fP
.RS 4
\fInum_bmls\fP (OUT) Returns the number of bml modules created, or 0 if the transport is not available.
.br
\fIenable_progress_threads\fP (IN) Whether this component is allowed to run a hidden/progress thread or not.
.br
\fIenable_mpi_threads\fP (IN) Whether support for multiple MPI threads is enabled or not (i.e., MPI_THREAD_MULTIPLE), which indicates whether multiple threads may invoke this component simultaneously or not.
.RE
.PP
\fBReturns:\fP
.RS 4
Array of pointers to BML modules, or NULL if the transport is not available.
.RE
.PP
During component initialization, the BML component should discover the physical devices that are available for the given transport, and create a BML module to represent each device. Any addressing information required by peers to reach the device should be published during this function via the mca_base_modex_send() interface. 
.SS "typedef int(* \fBmca_bml_base_module_add_procs_fn_t\fP)(size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_bml_base_endpoint_t\fP **endpoints, struct ompi_bitmap_t *reachable)"
.PP
PML->BML notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbml\fP (IN) BML module 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIprocs\fP (IN) Set of processes 
.br
\fIendpoint\fP (OUT) Set of (optional) \fBmca_bml_base_endpoint_t\fP structures by BML. 
.br
\fIreachable\fP (OUT) Bitmask indicating set of peer processes that are reachable by this BML. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure.
.RE
.PP
The \fBmca_bml_base_module_add_procs_fn_t()\fP is called by the PML to determine the set of BMLs that should be used to reach each process. Any addressing information exported by the peer via the mca_base_modex_send() function should be available during this call via the corresponding mca_base_modex_recv() function. The BML may utilize this information to determine reachability of each peer process.
.PP
For each process that is reachable by the BML, the bit corresponding to the index into the proc array (nprocs) should be set in the reachable bitmask. The PML provides the BML the option to return a pointer to a data structure defined by the BML that is returned to the BML on subsequent calls to the BML data transfer functions (e.g bml_send). This may be used by the BML to cache any addressing or connection information (e.g. TCP socket, IP queue pair). 
.SS "typedef int(* \fBmca_bml_base_module_del_procs_fn_t\fP)(size_t nprocs, struct ompi_proc_t **procs)"
.PP
Notification of change to the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIbml\fP (IN) BML module 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIproc\fP (IN) Set of processes 
.br
\fIpeer\fP (IN) Set of peer addressing information. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful
.RE
.PP
When the process list changes, the PML notifies the BML of the change, to provide the opportunity to cleanup or release any resources associated with the peer. 
.SS "typedef int(* \fBmca_bml_base_module_finalize_fn_t\fP)(void)"
.PP
MCA->BML Clean up any resources held by BML module before the module is unloaded. 
.PP
\fBParameters:\fP
.RS 4
\fIbml\fP (IN) BML module.
.RE
.PP
Prior to unloading a BML module, the MCA framework will call the BML finalize method of the module. Any resources held by the BML should be released and if required the memory corresponding to the BML module freed. 
.SS "typedef int(* \fBmca_bml_base_module_progress_fn_t\fP)(void)"
.PP
MCA->BML Called to progress outstanding requests for non-threaded polling environments. 
.PP
\fBParameters:\fP
.RS 4
\fItstamp\fP Current time. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error code on failure. 
.RE
.PP

.SS "typedef int(* \fBmca_bml_base_module_register_fn_t\fP)(mca_btl_base_tag_t tag, \fBmca_bml_base_module_recv_cb_fn_t\fP cbfunc, void *cbdata)"
.PP
Register a callback function that is called on receipt of a fragment. 
.PP
\fBParameters:\fP
.RS 4
\fIbml\fP (IN) BML module 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful
.RE
.PP
When the process list changes, the PML notifies the BML of the change, to provide the opportunity to cleanup or release any resources associated with the peer. 
.SH "Function Documentation"
.PP 
.SS "static mca_bml_base_btl_t* mca_bml_base_btl_array_find (\fBmca_bml_base_btl_array_t\fP * array, struct \fBmca_btl_base_module_t\fP * btl)\fC [inline, static]\fP"
.PP
Locate an element in the array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP (IN) 
.br
\fIindex\fP (IN) 
.RE
.PP

.SS "static mca_bml_base_btl_t* mca_bml_base_btl_array_get_index (\fBmca_bml_base_btl_array_t\fP * array, size_t index)\fC [inline, static]\fP"
.PP
Return an array item at the specified index. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP (IN) 
.br
\fIindex\fP (IN) 
.RE
.PP

.SS "static mca_bml_base_btl_t* mca_bml_base_btl_array_get_next (\fBmca_bml_base_btl_array_t\fP * array)\fC [inline, static]\fP"
.PP
Return the next LRU index in the array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP (IN) 
.br
\fIindex\fP (IN) 
.RE
.PP

.SS "static mca_bml_base_btl_t* mca_bml_base_btl_array_insert (\fBmca_bml_base_btl_array_t\fP * array)\fC [inline, static]\fP"
.PP
Grow the array size by one and return the item at that index. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP (IN) 
.RE
.PP

.SS "int mca_bml_base_btl_array_reserve (\fBmca_bml_base_btl_array_t\fP *, size_t)"
.PP
If required, reallocate (grow) the array to the indicate size. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP (IN) 
.br
\fIsize\fP (IN) 
.RE
.PP

.SS "static void mca_bml_base_btl_array_set_size (\fBmca_bml_base_btl_array_t\fP * array, size_t size)\fC [inline, static]\fP"
.PP
Grow the array if required, and set the size. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP (IN) 
.br
\fIsize\fP (IN) 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
